#include <windows.h>

#define MaxRxQueSize 500000

HANDLE hCom = INVALID_HANDLE_VALUE;
BYTE RxQue[MaxRxQueSize];
int Rxhead = 0;
int Rxtail = 0;

BOOL inRxQue( BYTE RXD )
{
	HANDLE hMutex;

	hMutex = CreateMutex( 0, FALSE, "mutex_rxque" );
	WaitForSingleObject( hMutex, INFINITE );

	if( (Rxtail + 1) % MaxRxQueSize != Rxhead ) {
		RxQue[Rxtail] = RXD;
		Rxtail++;
		Rxtail = Rxtail % MaxRxQueSize;

		ReleaseMutex( hMutex );
		CloseHandle( hMutex );

		return TRUE;
	}
	else {

		ReleaseMutex( hMutex );
		CloseHandle( hMutex );

		return FALSE;
	}
}

BOOL outRxQue( BYTE* RXD )
{
	HANDLE hMutex;

	hMutex = CreateMutex( 0, FALSE, "mutex_rxque" );
	WaitForSingleObject( hMutex, INFINITE );

	if( Rxtail != Rxhead ) {

		*RXD = RxQue[Rxhead];
		Rxhead++;
		Rxhead = Rxhead % MaxRxQueSize;
		
		ReleaseMutex( hMutex );
		CloseHandle( hMutex );

		return TRUE;
	}
	else {

		ReleaseMutex( hMutex );
		CloseHandle( hMutex );

		return FALSE;
	}
}

BOOL ComOpen( BYTE Port, DWORD Baud, BYTE StopBits )
{
	DCB dcb;

    DWORD DCB_BAUDRATE;
    BYTE  DCB_STOPBITS;

    char cPort[10];

    sprintf ( cPort, "COM%i", Port );

    switch ( Baud ) 
	{
	case    300 :  DCB_BAUDRATE = CBR_300;     break;        
	case    600 :  DCB_BAUDRATE = CBR_600;     break;
	case   1200 :  DCB_BAUDRATE = CBR_1200;    break;
	case   2400 :  DCB_BAUDRATE = CBR_2400;    break;
    case   4800 :  DCB_BAUDRATE = CBR_4800;    break;
    case   9600 :  DCB_BAUDRATE = CBR_9600;    break;            
    case  19200 :  DCB_BAUDRATE = CBR_19200;   break;
    case  38400 :  DCB_BAUDRATE = CBR_38400;   break;        
    case  57600 :  DCB_BAUDRATE = CBR_57600;   break;
	case 115200 :  DCB_BAUDRATE = CBR_115200;  break;
	default     :  return FALSE;
    }

    switch ( StopBits ) {
	case 1  :  DCB_STOPBITS = ONESTOPBIT;   break;        
	case 2  :  DCB_STOPBITS = TWOSTOPBITS;  break;
	default :  return FALSE;
    }

    hCom = CreateFile ( cPort, 
		                GENERIC_READ | GENERIC_WRITE,
                        0, NULL, OPEN_EXISTING, 0, NULL);

    if ( hCom == INVALID_HANDLE_VALUE )
		return( FALSE );

	//  / o̓obt@TCY
	SetupComm ( hCom, 1024, 1024 );

	GetCommState ( hCom, &dcb );

	//  {[[g
    dcb.BaudRate = DCB_BAUDRATE;
	//  Xgbvrbg
    dcb.StopBits = DCB_STOPBITS;


	//  ȉŒ
    dcb.fParity = 0;
    dcb.fOutxCtsFlow = 0;
    dcb.fOutxDsrFlow = 0;
    dcb.fDtrControl = DTR_CONTROL_ENABLE;
    dcb.fDsrSensitivity = FALSE;
    dcb.fTXContinueOnXoff = 0;
    dcb.fOutX = 0;
    dcb.fInX = 0;
    dcb.fErrorChar = 0;
    dcb.fNull = 0;
	dcb.fRtsControl = RTS_CONTROL_DISABLE;
    dcb.fAbortOnError = 0;
    dcb.ByteSize = 8;
    dcb.Parity = NOPARITY;

	SetCommState ( hCom, &dcb ); 
	SetCommMask  ( hCom, EV_TXEMPTY );

	return TRUE;
}

BOOL ComSnd( DWORD NumBytes, void *Buffer )
{
	DWORD EvtMask, BytesWritten;
	BOOL status;

    if ( (hCom == 0) || (hCom == INVALID_HANDLE_VALUE) )
		return FALSE;

    status = WriteFile ( hCom, Buffer, NumBytes, &BytesWritten, 0 );

	WaitCommEvent( hCom, &EvtMask, NULL );
 
    return TRUE;
}

void ComSETRTS()
{
	EscapeCommFunction ( hCom, SETRTS );
}

void ComCLRRTS()
{
	EscapeCommFunction ( hCom, CLRRTS );
}

BOOL ComClose()
{
	if ( (hCom == 0) || (hCom == INVALID_HANDLE_VALUE) )
		return FALSE;

    CloseHandle ( hCom );

	hCom = INVALID_HANDLE_VALUE;

    return TRUE;
}

BOOL ComStatusCTS( DWORD* status )
{
	if ( (hCom == 0) || (hCom == INVALID_HANDLE_VALUE) )
		return FALSE;

	GetCommModemStatus( hCom, status );

	if( *status & MS_CTS_ON )
		*status = 1;
	else
		*status = 0;

	return TRUE;
}

BOOL ComRcv( DWORD *BytesRead, DWORD BufferSize, void *Buffer )
{
	COMSTAT  ComStat;
    DWORD    ComErr, BytesToRead;

    if ( (hCom == 0) || (hCom == INVALID_HANDLE_VALUE) )
		return FALSE;

	ClearCommError( hCom, &ComErr, &ComStat);

    if ( ComStat.cbInQue > 0) {

        if ( ComStat.cbInQue > BufferSize) {
            BytesToRead = BufferSize;
        } else {
            BytesToRead = ComStat.cbInQue;
        }

        ReadFile ( hCom, Buffer, BytesToRead, BytesRead, NULL);

    } else {
        *BytesRead = 0;
    }

    return TRUE;
}

void WaitForRxD()
{
	unsigned int i;
	DWORD dwObj;
	HANDLE hMutex;
	DWORD BytesRead;
	BYTE Buffer[1025];

	ZeroMemory( Buffer, 1025 );

	hMutex = CreateMutex( 0, FALSE, "Tail_wags_the_dog" );

	// Ԃ𒲂ׂ
	dwObj = WaitForSingleObject( hMutex, 0 );

	if( dwObj != 0 )
		return ;

	// 
	while( 1 )
	{
		if( !ComRcv( &BytesRead, 1024, Buffer ) ) break;

		if( BytesRead > 0 ) {

			for( i=0; i<BytesRead; i++ ) {
				inRxQue( Buffer[i] );
			}
			Sleep(0);
		}
		else {
			Sleep(1);
			ZeroMemory( Buffer, 1024 );
		}
	}

	ReleaseMutex( hMutex );
	CloseHandle( hMutex );
}

// MXbh̊Jn
void ComRcvInit() 
{
	DWORD thID;

	// MXbh
	CreateThread( 0, 0, (LPTHREAD_START_ROUTINE)WaitForRxD, (VOID *)0, 0, &thID );
}

// |[g 1 WORD ǂ
WORD epn_inpw( BYTE port )
{
	BYTE TXD[5];
	BYTE SYNC, ADDR, HIBYTE, LOBYTE;
	int loop = 0;

	SYNC = 0x16;

	ZeroMemory( TXD, 5 );

	port = port & 0x0F; 

	// A0 ( 1010 0000 )
	*(TXD+0) = SYNC;
	*(TXD+1) = 0xA0 | port;
	*(TXD+2) = 0x00;
	*(TXD+3) = 0x00;


	ComSnd( 4, TXD );

	loop = 0;
	while( outRxQue( &SYNC ) == false ) {
		
		Sleep(1);
		
		if( loop == 10 ) 
			return -1;

		loop++;
	}

	loop = 0;
	while( outRxQue( &ADDR ) == false ) {
		
		Sleep(1);
		
		if( loop == 10 ) 
			return -1;

		loop++;
	}

	loop = 0;
	while( outRxQue( &HIBYTE ) == false ) {
		
		Sleep(1);
		
		if( loop == 10 ) 
			return -1;

		loop++;
	}

	loop = 0;
	while( outRxQue( &LOBYTE ) == false ) {
		
		Sleep(1);
		
		if( loop == 10 ) 
			return -1;

		loop++;
	}

	loop = 0;

	return MAKEWORD( LOBYTE, HIBYTE );
}

// |[g 1 WORD 
void epn_outpw( BYTE port, WORD data )
{
	BYTE SYNC;
	BYTE TXD[5];

	SYNC = 0x16;
	ZeroMemory( TXD, 5 );

	port = port & 0x0F;

	*(TXD+0) = SYNC;
	*(TXD+1) = 0x50 | port;
	*(TXD+2) = HIBYTE( data );
	*(TXD+3) = LOBYTE( data );

	ComSnd( 4, TXD );
}

// EPN001Zbg
void epn_reset()
{
	BYTE SYNC, RST_FLG;
	BYTE TXD[5];

	SYNC    = 0x16;
	RST_FLG = 0x1B;
	ZeroMemory( TXD, 5 );

	*(TXD+0) = SYNC;
	*(TXD+1) = RST_FLG;
	*(TXD+2) = HIBYTE( 0 );
	*(TXD+3) = LOBYTE( 0 );

	ComSnd( 4, TXD );
}